'From Squeak4.5 of 21 May 2014 [latest update: #13771] on 21 May 2014 at 9:31:05 pm'!
"Change Set:		LX-2
Date:			21 May 2014
Author:			David T. Lewis

Start using LXDateAndTime instead of DateAndTime.

Change instance creation in DateAndTime to create LXDateAndTime instances instead.

In the postscript, have DateAndTime instances become LXDateAndTime. Be patient, the initialization takes some time.
"!


!DateAndTime methodsFor: 'squeak protocol' stamp: 'dtl 5/14/2014 07:37'!
floor
	"Answer a copy with magnitude rounded down to the nearest whole second"
	^self class basicNew
		ticks: (self ticks at: 3 put: 0; yourself)
		offset: offset.
! !


!DateAndTime class methodsFor: 'ansi protocol' stamp: 'dtl 5/21/2014 21:30'!
now

	^LXDateAndTime now.
"	[ | timeArray |
	timeArray := self primPosixMicrosecondClockWithOffset.
	^ self utcMicroseconds: timeArray first offset: timeArray second]
		on: Error
		do: [ ""Use old style primitive support""
			^self nowWithOffset: self localOffset]"! !

!DateAndTime class methodsFor: 'smalltalk-80' stamp: 'dtl 4/16/2014 20:41'!
fromSeconds: seconds 
	"Answer a DateAndTime since the Squeak epoch: 1 January 1901"

	^ LXDateAndTime fromSeconds: seconds
"	| integerSeconds nanos |
	integerSeconds := seconds truncated.
	integerSeconds = seconds
		ifTrue: [nanos := 0]
		ifFalse: [nanos := (seconds - integerSeconds * NanosInSecond) asInteger].
	^ self basicNew
		ticks: (Array
				with: SqueakEpoch
				with: integerSeconds
				with: nanos)
		offset: self localOffset"! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'dtl 4/16/2014 20:40'!
julianDayNumber: anInteger offset: aDuration
	^ LXDateAndTime julianDayNumber: anInteger offset: aDuration
"	^ self basicNew
		ticks: anInteger days ticks
		offset: aDuration ;
		 yourself"! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'dtl 4/16/2014 20:40'!
year: year month: month day: day hour: hour minute: minute second: second nanoSecond: nanoCount offset: offset
	"Return a DateAndTime"

	^ LXDateAndTime year: year month: month day: day hour: hour minute: minute second: second nanoSecond: nanoCount offset: offset
"	| monthIndex daysInMonth p q r s julianDayNumber |

	monthIndex := month isInteger ifTrue: [month] ifFalse: [Month indexOfMonth: month].
	daysInMonth := Month
		daysInMonth: monthIndex
		forYear: year.
	day < 1 ifTrue: [self error: 'day may not be zero or negative'].
	day > daysInMonth ifTrue: [self error: 'day is after month ends']. 	
	
	p := (monthIndex - 14) quo: 12.
	q := year + 4800 + p.
	r := monthIndex - 2 - (12 * p).
	s := (year + 4900 + p) quo: 100.

	julianDayNumber :=
 		( (1461 * q) quo: 4 ) +
			( (367 * r) quo: 12 ) -
 				( (3 * s) quo: 4 ) +
 					( day - 32075 ).

	^self basicNew
		setJdn: julianDayNumber 
		seconds: hour * 60 + minute * 60 + second
		nano: nanoCount
		offset: offset;
		yourself"! !


!LXDateAndTime methodsFor: 'squeak protocol' stamp: 'dtl 5/20/2014 23:39'!
floor
	"Answer a copy with magnitude rounded down to the nearest whole second"
	^self class
		utcMicroseconds: utcMicroseconds - (utcMicroseconds \\ 1000000)
		offset: localOffsetSeconds! !


!LXDateAndTime class methodsFor: 'initialize-release' stamp: 'dtl 7/13/2009 13:08'!
initialize

	super initialize.

	ClockProvider := Time.
	LastTickSemaphore := Semaphore forMutualExclusion.
	LastMilliSeconds := 0.
	LastTick := 0.
	Smalltalk addToStartUpList: self.
	self startUp: true
! !


!String methodsFor: '*Kernel-Chronology' stamp: 'dtl 5/12/2014 12:14'!
asLXDateAndTime

	^ LXDateAndTime fromString: self! !


!TimeStamp class methodsFor: 'squeak protocol' stamp: 'dtl 4/18/2014 11:39'!
current

	^self now! !

TimeStamp class removeSelector: #now!
LXDateAndTime initialize!
"Postscript:
Convert all instances of DateAndTime and TimeStamp to the equivalent LXDateAndTime and LXTimeStamp."

Smalltalk garbageCollect.
DateAndTime allInstancesDo: [: e | e become: e asLXDateAndTime].
TimeStamp allInstancesDo: [: e | e become: e asLXTimeStamp].
Smalltalk garbageCollect.

ObjectHistory current restartMarkProcess.
!

